﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;

namespace BresenhamEllipse
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void DrawLines(bool multi)
        {            
            WriteableBitmap writeableBitmap;
            writeableBitmap = new WriteableBitmap(
                200,
                200,
                96,
                96,
                PixelFormats.Bgr32, null);
            image1.Source = writeableBitmap;
            image1.Stretch = Stretch.None;
            image1.HorizontalAlignment = HorizontalAlignment.Left;
            image1.VerticalAlignment = VerticalAlignment.Top;
            Random rand = new Random();
            writeableBitmap.Lock();
            WriteableBitmapDrawer writeableBitmapDrawer = new WriteableBitmapDrawer(writeableBitmap);
            int count;
            if (multi) count = 50 * 1000; else count = 1;
            for (int i = 0; i < count; i++)
            {
                int radius_a = rand.Next(100);
                int radius_b = rand.Next(100);
                writeableBitmapDrawer.DrawEllipse(
                        100, 100, radius_a, radius_b
                        , 255 * 256 * 256);
                if (!multi) 
                {
                    labelRA.Content = radius_a.ToString();
                    labelRB.Content = radius_b.ToString();
                }
            }
            writeableBitmap.AddDirtyRect(new Int32Rect(0, 0, 200, 200));
            writeableBitmap.Unlock();
        }        
        
        private void button1_Click(object sender, RoutedEventArgs e)
        {                        
            DrawLines(false);           
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            long cntA, cntB, f;
            QueryPerformanceCounter(out cntA);
            DrawLines(true);
            QueryPerformanceCounter(out cntB);
            QueryPerformanceFrequency(out f);
            MessageBox.Show("czas "+((int)((double)(cntB - cntA) / f *1000)).ToString()+" ms");
        }        

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("kernel32")]
        private static extern bool QueryPerformanceFrequency(out long performanceFrequency);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("kernel32")]
        private static extern bool QueryPerformanceCounter(out long performanceCount);
        

    }
}
